package foo;

import java.io.*;
import java.util.*;

class Cmp implements Comparator<Pair> {
    public int compare(Pair a, Pair b) {
        return b.getValue().compareTo(a.getValue());
    }
}

class Pair {
    private String key;
    private Integer value;

    public Pair(String a, Integer b) {
        key = a;
        value = b;
    }

    public Integer getValue() {
        return value;
    }

    public String getKey() {
        return key;
    }
}

public class WordCounter {
    private static HashMap<String, Integer> map = new HashMap();
    private static int wNum = 0;

    public static void main(String args[]) {
        if (args.length > 0) {
            readWords(args[0]);
        } else {
            System.out.println("Please, specify the file");
        }
    }

    static void printTable() {
        List<Pair> lst = new ArrayList<Pair>();

        for(Map.Entry<String, Integer> entry : map.entrySet()) {
            lst.add(new Pair(entry.getKey(), entry.getValue()));
        }

        Collections.sort(lst, new Cmp());
        for(Pair entry : lst) {
            System.out.println(entry.getKey() + ";" + entry.getValue() + ";" + (double)entry.getValue() / wNum);
        }
    }

    static void readWords(String fileName) {
        FileInputStream stream = null;

        try {
            stream = new FileInputStream(fileName);
            byte[] buf = new byte[stream.available()];
            stream.read(buf);

            String str = new String(buf);

            String[] strArr = str.split("[^A-Za-z0-9]");

            for(String s:strArr) {
                map.put(s, 1 + (map.containsKey(s) ? map.get(s) : 0));
                wNum++;
            }

            printTable();
        }
        catch (IOException e) {
            System.err.println("Error while reading file: " + e.getLocalizedMessage());
        }
        finally {
            if (null != stream) {
                try {
                    stream.close();
                }
                catch (IOException e) {
                    e.printStackTrace(System.err);
                }
            }
        }
    }
}
